Bug 29558 - воспроизводимые проблемы с правами на squashfs, появившиеся в 0.2.9
: воспроизводимые проблемы с правами на squashfs, появившиеся в 0.2.9
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/mkimage)
: unstable
: all Linux
: P3 blocker
Assigned To:
:
:
:
:
: 27685
  Show dependency tree
 
Reported: 2013-11-06 19:50 by
Modified: 2013-11-13 15:56 (History)


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2013-11-06 19:50:28
На регулярных сборках недавно сломались скринсейверы с диагностикой вроде:

Oct 28 12:41:53 localhost UNSPECIFIED
(__progname="mate-screensaver-chkpwd-helper" uid=500 gid=500 egid=24)[12366]:
pam_authenticate(mate-screensaver, altlinux): Authentication failure

Было выяснено, что причиной являются неправильные права на /etc/tcb: группа
root вместо shadow (сами биты разрешений выставлены правильно).  Также
оказалось, что права на подкаталоги /etc/tcb/*/ частично тоже сломаны -- около
половины из них вместо $USER:auth принадлежат root:root (биты при этом
правильные).

В mkimage-profiles за этот период никаких подобных изменений не было; в
installer-features* тоже не припоминаю.

Возникло подозрение, что это мог оказаться сюрприз имени aufs; это также
подкрепляется наблюдением, что в снапшоте starterkits за 20131028 наблюдается
та же проблема.  При этом в образе за 20131016 с 3.10.16 проблема не
воспроизводится.

По сути блокер для всех образов с применением livecd-install и потенциальный
источник трудноуловимых багов -- для обычных инсталеров.

good: http://nightly.altlinux.org/debug/regular-mate-20131016-i586.iso
 bad: http://nightly.altlinux.org/debug/regular-mate-20131023-i586.iso
------- Comment #1 From 2013-11-06 19:53:18 -------
PS: на 3.10.18 тоже воспроизводится, почему и вешаю.
------- Comment #2 From 2013-11-06 20:19:32 -------
PPS: по un-def (входит в regular-icewm.iso):
- 3.11.5 работало
- 3.11.6 сломалось
- 3.11.7 сломано
------- Comment #3 From 2013-11-07 14:30:15 -------
Проверь ядро из #108015. Во всяком случае у меня права на /etc/tcb с ним
правильные.
------- Comment #4 From 2013-11-07 16:58:21 -------
У меня неправильные, _но_ они неправильные и на /.ro/etc/tcb/; распаковал файл
live отдельно -- там уже неправильные.  Смотрю дальше, но aufs в этом случае
явно не виноват.
------- Comment #5 From 2013-11-07 17:34:50 -------
Выяснилось, что проблема в изменении работы с .fakedata в
http://git.altlinux.org/gears/m/mkimage.git?p=mkimage.git;a=commitdiff;h=1222c05a5bf2b1927d9d67f3862e53bb6e008733
-- откат этого коммита исправляет ситуацию.

Осталось понять, что с ним не так и почему.
------- Comment #6 From 2013-11-07 21:09:38 -------
Не так с ним то, что модификация содержимого /.fakeroot была перенесена под
вызов mki-run, который безусловно вызывает hsh-run --rooter, который безусловно
запускает нужное под fakeroot, который при выходе переписывает этот файл.

Т.е. все сделанные под mki-run изменения /.fakeroot оказывались ничтожными.

Поскольку предыдущая реализация (до 0.2.9) в принципе могла быть использована
для организации в чруте выполнения кода вне чрута, решили коммит g1222c05 не
откатывать, а исправлять:
http://git.altlinux.org/people/mike/packages/?p=mkimage.git;a=commitdiff;h=9f429562d31397fdae9cdb95ec3d2e0eb2d91574
------- Comment #7 From 2013-11-08 04:47:46 -------
mkimage-0.2.10-alt1 -> sisyphus:

* Thu Nov 07 2013 Michael Shigorin <mike@altlinux> 0.2.10-alt1
- mki-image-prepare: fixed the change made in 0.2.9 (ldv@) (ALT#29558)